
Program endliche_Maschine_ohne_Ausgabe;

uses tpcrt;

type Band_Fortsetzung = ^Band_Stelle;

     Band_Stelle = Record
                      Stelle      : string[10];
                      Stellen_Nr  : integer;
                      right       : Band_Fortsetzung;
                      left        : Band_Fortsetzung;
                   End;

     saetze =  Record
                  regel:       string[3];
                  afiller:     string[1];
                  code:        string[1];
                  bfiller:     string[1];
                  verzweigung: string[3]
               end;
     asaetze = array[1..100] of saetze;

     str_1  = string[1];
     str_3  = string[3];
     str_10 = string[10];
     str_12 = string[12];

var  j,
     Stelle,
     Befehl_Nr,
     Max_Befehle        : integer;
     Befehl             : asaetze;
     Datei              : text;
     DosDatei           : str_12;
     Abbruch            : boolean;
     Band_Anfang,
     Schreibkopf,
     Band_Ende,
     DruckStelle,
     Before,Next,
     Neues_Element       : Band_Fortsetzung;
     Laenge,
     Anzahl,
     Frequenz,
     BandStelle,
     Band_Stellenzahl,
     SchreibkopfStelle,
     Zaehler             : integer;
     m,
     l,
     Art_str,
     Ende                : str_1;
     k,
     Regel_Nr            : str_3;
     Zahl                : str_10;
     Art,aa              : char;

{ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - }


procedure Set_Color(i:integer);
begin
  case i of
    1 : begin TextColor(White); TextBackGround(Black); end;
    2 : begin TextColor(Black); TextBackGround(White); end;
  end;
end;  { proc set_Color }


procedure set_Rahmen(x1,y1,x2,y2:integer);
var j:integer;
begin
  j:=0;
  GotoXY(x1,y1); write(chr(218));
  FOR j:=x1+1 TO x2-1 DO write(chr(196));
  write(chr(191));
  FOR j:=y1+1 TO y2-1 DO
  begin
     GotoXY(x1,j); write(chr(179));
     GotoXY(x2,j); write(chr(179));
  end;
  GotoXY(x1,y2); write(chr(192));
  FOR j:= x1+1 TO x2-1 DO write(chr(196));
  write(chr(217));
end;   { proc set_Rahmen }


procedure install_Windows;
var i,j:integer;
begin
  set_Rahmen(1,1,26,23);
  GotoXY(8,1); Write(' Lese-Band ');
  set_Rahmen(27,1,80,17);
  GotoXY(43,1); Write(' Automaten-Zustnde ');
  set_Rahmen(27,18,53,23);
  GotoXY(28,18); Write(' Neuer Maschinen-Zustand ');
  set_Rahmen(54,18,80,20);
  GotoXY(58,18); Write(' Lese-Band-Stelle ');
  set_Rahmen(54,21,80,23);
  GotoXY(57,21); Write(' Band-Lauf-Frequenz ');
end;  { proc install_Windows }


procedure Set_Window(i:integer);
begin
  Window(1,1,80,25);
  case i of
    0 : Window(1,1,80,25);
   13 : Window(28,2,79,16);         { Automaten - Zustnde }
    2 : begin                    { Neuer Maschinen-Zustand }
          Set_Color(1); Window(28,19,52,22);
        end;
   21 : begin                           { Lese-Band-Stelle }
          Set_Color(1);
          Window(55,19,79,20); GotoXY(13,1);
        end;
   23 : begin                         { Band-Lauf-Frequenz }
          Set_Color(1);
          Window(55,22,79,23); GotoXY(12,1);
        end;
    3 : begin                    { Eingabe/Anfrage - Zeile }
          Window(1,24,80,25); Set_Color(1);
          GotoXY(1,1); Write('>> '); ClrEol;
        end;
    4 : begin                    { Eingabe/Anfrage - Zeile }
          Set_Color(1);
          Window(1,24,80,25); GotoXY(1,1);
          Write('>> '); ClrEol; Set_Color(2);
          GotoXY(1,2); ClrEol;
        end;
    5 : begin
          Window(2,2,25,22); LowVideo;
          GotoXY(1,11); Write('==>         <== LeseKopf');
        end;
   51 : begin Window(6,2,12,22); LowVideo; end;
  end;
end;  { proc set_Window }


function Datei_einlesen(var Max_Befehle:integer;
                         var Befehl:asaetze):boolean;
var i:integer; flag:Boolean;
begin
   Datei_einlesen:=false; flag:=false; i:=0;
   Repeat
     Set_Window(4); GotoXY(22,2);
     Write('Datei des auszufhrenden Automaten?');
     Set_Color(1); GotoXY(4,1); ReadLn(DosDatei);
     Assign(Datei,DosDatei);
     {$I-} Reset(Datei); {$I+}
     if IOresult=0 then
     begin
       While not(eof(Datei)) do
       begin
          Max_Befehle:=Max_Befehle+1;
          With Befehl[Max_Befehle] Do
          ReadLn(datei,regel,afiller,
                       code,bfiller,verzweigung);
       end;
       close(Datei);
       flag:=true;
       Datei_einlesen:=true;
     end
     else begin
       Set_Window(3); GotoXY(4,1);
       Write(' Automat: ',DosDatei,' ist auf Diskette/');
       Write('Platte nicht verfgbar!');
       i:=i+1;
       if i=4 then Abbruch:=true;
       Delay(3000);
     end;
   Until flag or Abbruch;
end;  { func Datei_einlesen }


Procedure Automaten_Druck(Befehl:asaetze;
                            Max_Befehle:integer);
var j,Zeile,Spalte:integer;
begin
  LowVideo; Set_Window(13); Zeile:=1; Spalte:=2;
  For j:=1 TO Max_Befehle Do begin
    Delay(50);
    GotoXY(Spalte,Zeile); Zeile:=Zeile+1;
    With Befehl[j] Do if j<=75 then
      Write(regel,afiller,code,bfiller,verzweigung);
    IF Zeile=16 THEN begin Zeile:=1; Spalte:=Spalte+10; end;
  end;
  HighVideo;
end;  { proc Automaten_Druck }


Procedure Zustand_drucken(var Spalte,Zeile,j_Merker:integer;
                          Befehl:asaetze; Befehl_Nr:integer);
begin
  Set_Window(13); GotoXY(Spalte,Zeile);
  LowVideo;
  With Befehl[j_Merker] Do
      Write(regel,afiller,code,bfiller,verzweigung);
  HighVideo;
  Case Befehl_Nr of
    1..15  : Spalte:=2;
    8..30 : Spalte:=12;
   15..45 : Spalte:=22;
   22..60 : Spalte:=32;
   29..75 : Spalte:=42;
  end;
  Case Befehl_Nr of
    1..15 : Zeile:=Befehl_Nr;
   16..30 : Zeile:=Befehl_Nr-15;
   31..45 : Zeile:=Befehl_Nr-30;
   46..60 : Zeile:=Befehl_Nr-45;
   61..75 : Zeile:=Befehl_Nr-60;
  end;
  Set_Window(13); GotoXY(Spalte,Zeile);
  With Befehl[Befehl_Nr] Do
      Write(regel,afiller,code,bfiller,verzweigung);
  LowVideo; j_Merker:=Befehl_Nr;
end;  { proc Zustand_drucken }


procedure BandStellenDruck(Druckstelle:Band_Fortsetzung;
                                                 art:char);
begin
  Case Art of
   'r' : begin
      Set_Window(51); GotoXY(1,1); InsLine;
      if Druckstelle^.Stellen_Nr mod 5 = 0 then
        Write(Druckstelle^.Stelle,'  ',Druckstelle^.Stellen_Nr)
      else Write(Druckstelle^.Stelle);
      end;
   '' : begin
      Set_Window(51); GotoXY(1,11);
      if Druckstelle^.Stellen_Nr mod 5 = 0 then
        Write(Druckstelle^.Stelle,'  ',Druckstelle^.Stellen_Nr)
      else Write(Druckstelle^.Stelle);
      end;
   'g' : begin
      Set_Window(51); GotoXY(1,1);
      if Druckstelle^.Stellen_Nr mod 5 = 0 then
      begin
        InsLine;
        Write(Druckstelle^.Stelle,'  ',Druckstelle^.Stellen_Nr);
        Delay(100);
      end
      else begin
        InsLine; Write(Druckstelle^.Stelle); Delay(100);
      end;
   end
   else  end;
end;  { proc BandStellenDruck }


Procedure Band_Generierung(Anzahl:integer; Art_str:str_1);
var i:integer;
begin
  if Art_str<>Chr(254) then
  begin
    for i:=1 to Anzahl do
    begin
      new(Next);
      Schreibkopf^.Right:=Next;
      Next^.Left:=Schreibkopf;
      Schreibkopf:=Next;
      Band_Stellenzahl:=Band_Stellenzahl+1;
      Schreibkopf^.Stelle:=Art_str;
      Schreibkopf^.Stellen_Nr:=Band_Stellenzahl;
      Next:=nil;
      BandStellenDruck(Schreibkopf,'g');
    end
  end
  else begin
    for i:=1 to Anzahl do
    begin
      new(Next);
      Schreibkopf^.Right:=Next;
      Next^.Left:=Schreibkopf;
      Schreibkopf:=Next;
      Band_Stellenzahl:=Band_Stellenzahl+1;
      if i=1 then Schreibkopf^.Stelle:='s'
        else Schreibkopf^.Stelle:=Art_str;
      Schreibkopf^.Stellen_Nr:=Band_Stellenzahl;
      Next:=nil;
      BandStellenDruck(Schreibkopf,'g');
    end
  end;
end; { proc Band_Generierung }


Procedure Band_Eingabe;
begin
  Repeat
    Set_Window(4); GotoXY(2,2);
    Write('Welches Zeichen:   ''0'' fr Nullen, ''1'' fr ');
    Write('Einsen bzw. ''2'' fr Leerzeichen ''''');
    Set_Window(3); GotoXY(4,1); ReadLn(Art_str);
    if Art_str='2' then Art_str:=Chr(254);
    if Art_str<>Chr(254) then
    begin
      GotoXY(4,1); ClrEol;
      Set_Window(4); GotoXY(28,2);
      Write('Anzahl dieses Zeichens?');
      Set_Window(3); GotoXY(4,1); ReadLn(Anzahl);
    end
    else Anzahl:=1;
    GotoXY(4,1); ClrEol;
    Band_Generierung(Anzahl,Art_str);
  Until Art_str=Chr(254);
  Set_Window(3); GotoXY(1,2); ClrEol;

  Set_Window(4); GotoXY(22,2);
  Write('Anfangszustand ist die Band-Stelle: 1 ');
  Delay(2000); SchreibkopfStelle:=1;
  Set_Window(4); GotoXY(19,2);
  Write('Geben Sie die Ablaufgeschwindigkeit an ');
  Set_Window(3); GotoXY(4,1); ReadLn(Frequenz);
End;  { proc Band_Eingabe }


procedure Maschinen_Lauf;
var c,
    Spalte,Zeile,
    j_Merker      : integer;
begin
  Regel_Nr:='000'; m:='0'; c:=0;
  j_Merker:=1; Spalte:=2; Zeile:=1;
  Set_Window(51); GotoXY(1,1);
  for j:=1 to 21 do DelLine;    { Window-Inhalt lschen }
  Delay(500); Set_Window(5);
  Delay(700); Set_Window(51);
  DruckStelle:=Band_Anfang;
  BandStelle:=SchreibkopfStelle; Delay(200);

  { Ausdrucken bis zur oberen Window-Grenze Zeile 1 }
  for j:=DruckStelle^.Stellen_Nr to SchreibkopfStelle+9 do
  begin
    if DruckStelle^.Stellen_Nr<Band_Ende^.Stellen_Nr then
    begin
      DruckStelle:=DruckStelle^.Right;
      BandStellenDruck(DruckStelle,'g');
    end
    else if DruckStelle^.Stellen_Nr=Band_Ende^.Stellen_Nr then
    begin
      new(Next);
      Band_Ende^.Right:=Next;
      Next^.Left:=Band_Ende;
      Band_Ende:=Next;
      Band_Stellenzahl:=Band_Stellenzahl+1;
      Band_Ende^.Stellen_Nr:=Band_Stellenzahl;
      Band_Ende^.Stelle:='';
      DruckStelle:=Next; Next:=nil;
      BandStellenDruck(DruckStelle,'g');
    end
    else begin
      Set_Window(5); GotoXY(4,1);
      Write('Lauf-Fehler! Abbruch des Programms!');
      HALT;
    end;
  end;

  Schreibkopf:=Band_Anfang;
  while SchreibkopfStelle>Schreibkopf^.Stellen_Nr do
                          Schreibkopf:=Schreibkopf^.Right;
  Next:=Schreibkopf; Before:=Schreibkopf;
  for j:=1 to 10 do begin
    if not (Next^.Stellen_Nr=Band_Ende^.Stellen_Nr) then
      Next:=Next^.Right;
  end;
  for j:=1 to 10 do begin
    if not (Before^.Stellen_Nr=Band_Anfang^.Stellen_Nr) then
      Before:=Before^.Left;
  end;

  Set_Window(23); GotoXY(11,1); LowVideo; Write(Frequenz);
  Set_Window(21); LowVideo; Write(BandStelle);

  Set_Window(3); GotoXY(4,1); ClrEol;
  Set_Window(4); GotoXY(25,2);
  Write(' START mit beliebiger Taste ');
  Repeat aa:=Readjez; Until aa<>'?';
  Set_Window(3); GotoXY(4,1); ClrEol;
  Set_Window(4); GotoXY(25,2);
  Write('                            ');


  Repeat

  Delay(Frequenz);

  Repeat Befehl_Nr:=Befehl_Nr+1;
         c:=c+1; if c>1000 then Abbruch:=true;
         if Befehl_Nr>Max_Befehle then Befehl_Nr:=1;
         k:=Befehl[Befehl_Nr].regel;
         l:=Befehl[Befehl_Nr].code;
  until ((Regel_Nr=k) and (Schreibkopf^.Stelle=l)) or Abbruch;

  if not Abbruch then begin
    Zustand_drucken(Spalte,Zeile,j_Merker,Befehl,Befehl_Nr);
    Set_Window(2); LowVideo;
    With Befehl[Befehl_Nr] Do begin
      GotoXY(9,1); DelLine; GotoXY(9,4);
      Write(regel,afiller,code,bfiller,verzweigung);
    end;
    Set_Window(21); LowVideo; Write(BandStelle);
    BandStelle:=BandStelle+1;

    if not (Schreibkopf^.Stelle='') and
       not (Schreibkopf^.Stelle='s')        then
    begin
      if (Next^.Stellen_Nr=Band_Ende^.Stellen_Nr) then
      begin
        new(Neues_Element);
        Band_Ende^.Right:=Neues_Element;
        Neues_Element^.Left:=Band_Ende;
        Band_Ende:=Neues_Element;
        Neues_Element:=nil;
        Band_Stellenzahl:=Band_Stellenzahl+1;
        Band_Ende^.Stelle:='';
        Band_Ende^.Stellen_Nr:=Band_Stellenzahl;
      end;
      if Schreibkopf^.Stellen_Nr-10=Before^.Stellen_Nr then
        Before:=Before^.Right;
      Next:=Next^.Right; Schreibkopf:=Schreibkopf^.Right;
      art:='r'; BandStellenDruck(Next,art);
    end;

    Regel_Nr:=Befehl[Befehl_Nr].verzweigung;
  end;

  Until (Befehl[Befehl_Nr].code='s') or Abbruch;
end;  { proc Maschinen_Lauf }


procedure Ende_Kommentar;
begin
  if Befehl[Befehl_Nr].code='s' then
  begin
    Set_Window(4); GotoXY(20,2);
    Write('Halten des endlichen Automaten im Endzustand');
  end
  else begin
    Set_Window(4); GotoXY(5,2);
    Write('Vorzeitiges Halten! Das Band-Wort gehrt ');
    Write('nicht zum endlichen Automaten!');
  end;
end;  { proc Ende_Kommentar }


Procedure Cursor(i:integer);
begin
  Case i of
   1 : HiddenCursor;
   2 : BlockCursor;
   else end;
end;  { proc Cursor }


Procedure initialisieren;
begin
  Abbruch:=false;
  j:=0; Zahl:='0'; Max_Befehle:=0; Befehl_Nr:=0;
end;  { proc initialisieren }



begin   { - - - - -  H A U P T P R O G R A M M  - - - - - }
  Window(1,1,80,25); ClrScr; Cursor(1);
  initialisieren; install_Windows; Set_Window(11);

  if Datei_Einlesen(Max_Befehle,Befehl) then
    Automaten_Druck(Befehl,Max_Befehle)
  else begin
    set_Window(3); GotoXY(4,1);
    Write('Keine Datei kann eingelesen werden!');
    Delay(2000);
  end;

  if not Abbruch then begin
    new(Band_Anfang); Schreibkopf:=Band_Anfang;
    Band_Anfang^.Stelle:=''; Band_Anfang^.Stellen_Nr:=0;
    Band_Stellenzahl:=0; art:=' ';
    SchreibkopfStelle:=0;

    Delay(600); Band_Eingabe;

    Band_Ende:=nil;          Band_Ende:=Schreibkopf;
    Schreibkopf:=nil;        Schreibkopf:=Band_Anfang;
    Next:=nil;               Next:=Band_Anfang;
    Next:=Next^.Right;

    Maschinen_Lauf;

    Ende_Kommentar;
    Repeat aa:=Readjez; Until aa<>'?';
  end;

  Set_Window(0); GotoXY(1,1); Cursor(2);
end.   { Programm endliche_Maschine_ohne_Ausgabe }